//Progetto Esame di Programmazione Procedurale 2021 - "TRANNOI" - Carlicchi Francesco (matricola 331792)


//Definizione delle macro per i colori
#define red_color "\x1b[31m"
#define blue_color "\x1b[34m"
#define yellow_color "\x1b[33m"
#define green_color "\x1b[32m"
#define white_color "\x1b[37m"


//Enum per lo stato del giocatore in partita
enum Stato_giocatore { astronauta, impostore, assassinato, defenestrato };
//Enum per i nomi dei giocatori
enum Nome_giocatore { Rosso, Blu, Giallo, Verde, Rosa, Nero, Arancio, Marrone, Bianco, Viola };
//Enum per il tipo di una stanza
enum Tipo_stanza { vuota, quest_semplice, quest_complicata, botola };
//Enum per il nome di una stanza
enum Nome_stanza { caffetteria, elettrica, generatore, motore, reattore, navigazione, sicurezza, magazzino, armeria, aereazione };
//Enum per i punti cardinali (usati per la creazione delle stanze)
enum Punti_cardinali { nord, sud, est, ovest };
//Enum per una variabile di tipo booleano
enum Bool { false, true };
typedef enum Bool bool;


//Struttura per definire una stanza
struct Stanza {
  struct Stanza *nord, *sud, *est, *ovest; //Puntatori alle stanze adiacenti
  struct Stanza *successiva; //Puntatore per la lista dinamica
  enum Tipo_stanza tipo;
  enum Nome_stanza nome_stanza;
  bool emergenza_chiamata;
  short int x_pos, y_pos; //Coordinate della stanza
};

//Struttura per definire un giocatore
struct Giocatore {
  struct Stanza* posizione;
  enum Stato_giocatore stato;
  enum Nome_giocatore nome;
};


//Dichiarazione delle funzioni da usare nel main
void menu_principale(void);
void imposta_gioco(void);
void gioca(void);
void termina_gioco(void);
void storia(void);
void crediti(void);
